#include<iostream>
#include<vector>
using namespace std;


bool hashCompare(string a, string b) {
	const int MOD = 1000000007, base = 26;
	int n = a.size(), m = b.size();
	int aHash = 0, bHash = 0, baseToM = 1;
	
	for(int i=0;i<m;i++) {
		aHash = (1LL * aHash * base + a[i]) % MOD;
		bHash = (1LL * bHash * base + b[i]) % MOD;
		baseToM = 1LL * baseToM * base % MOD;
	}
	
	for(int i=0;i+m < n; i++) {
		if(aHash == bHash)
			return true;
		aHash = ((1LL * aHash * base - 1LL * a[i] * baseToM + a[i+m]) % MOD + MOD) % MOD;
	}
	return aHash == bHash;
}


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	
	int n, m;
	cin >> n >> m;
	
	string a, b;
	cin >> a >> b;
	
	if(hashCompare(a, b) )
		cout << "jah\n";
	else
		cout << "ei\n";
	return 0;
}