#include<iostream>
#include<vector>
using namespace std;


vector<int> constructP(string b) {
	int M = b.size();
	
	vector<int> p(b.size());
	p[0] = 0;
	
	for(int i=1;i<M;i++) {
		p[i] = p[i-1];
		while(p[i] > 0 && b[i] != b[p[i]])
			p[i] = p[p[i]-1];
		if(b[i] == b[p[i]])
			p[i]++;
	}
	
	return p;
}

int kmpCount(string a, string b) {
	int N = a.size(), M = b.size(), result = 0;
	
	vector<int> d(N), p = constructP(b);
	d[0] = a[0] == b[0];
	
	for(int i=1;i<N;i++) {
		d[i] = d[i-1];
		while(d[i] > 0 && (d[i] == M || b[d[i]] != a[i]) )
			d[i] = p[d[i]-1];
		if(b[d[i]] == a[i])
			d[i]++;
		if(d[i] == M)
			result++;
	}
	
	return result;
}



int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	
	int n, m;
	cin >> n >> m;
	string a, b;
	cin >> a >> b;
	
	cout << kmpCount(a, b) << '\n';
	return 0;
}

