#include<iostream>
#include<vector>
#include<string>
#include<deque>
#include<map>
using namespace std;


struct Trie {
	struct Node {
		map<char, Node*> next;
		int appearance = -1;
	};
	deque<Node> nodes;
	Node* root;
	
	Trie() {
		nodes.resize(1);
		root = &nodes[0];
	}
	
	void addString(string a, int index) {
		Node* cur = root;
		for(auto c : a) {
			if(!cur->next.count(c)) {
				nodes.push_back(Node());
				cur->next[c] = &nodes.back();
			}
			cur = cur->next[c];
		}
		cur->appearance = index;
	}
	
	int appears(string a) {
		Node* cur = root;
		for(auto c : a) {
			if(!cur->next.count(c))
				return -1;
			cur = cur->next[c];
		}
		return cur->appearance;
	}
};



int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	
	Trie trie;
	int n;
	cin >> n;
	
	for(int i=0;i<n;i++) {
		int len;
		string s;
		cin >> len >> s;
		trie.addString(s, i+1);
	}
	
	int m;
	cin >> m;
	
	for(int i=0;i<m;i++) {
		int len;
		string s;
		cin >> len >> s;
		cout << trie.appears(s) << '\n';
	}
	
	return 0;
}

